#include "QdpShmTraderApi.h"
#include <iostream>
#include <cstdlib>
#include <string.h>
#include <stdio.h>
#include <thread>
#include <chrono>

#ifdef WIN32
#define WINDOWS
#endif
using namespace std;

// 报单录入操作是否完成的标志
// 经纪公司代码
TQdpFtdcBrokerIDType g_chBrokerID;
// 交易用户代码
TQdpFtdcUserIDType g_chUserID;
// 投资者编号
TQdpFtdcInvestorIDType g_chInvestorID;
// 用户本地最大报单号
int g_nOrdLocalID = 0;
/// 交易API
CQdpShmTraderApi *g_pShmTraderApi = NULL;

void OrderFunc();

int ReqOrderAction(int RequestID);

int ReqOrderInsert(int RequestID);

class CShmTraderSpi : public CQdpShmTraderSpi
{
public:
    explicit CShmTraderSpi(CQdpShmTraderApi *pUserApi):m_pTraderApi(pUserApi){};
	~CShmTraderSpi(){
        orderThread.join();
    };

    // 实现CTraderSpi的各个接口
    virtual void OnFrontConnected()
    {
        std::cout << "OnFrontConnected\n";
        //连接后登录
        //ReqLogin();
        //连接后认证
        ReqAuth();
    };

    void ReqLogin()
    {
        CQdpFtdcReqUserLoginField reqUserLogin;

        strcpy(reqUserLogin.UserProductInfo, "test");
        strcpy(reqUserLogin.BrokerID, g_chBrokerID);
        strcpy(reqUserLogin.UserID, g_chUserID);
        strcpy(reqUserLogin.Password, "1");
        // 发出登陆请求
        m_pTraderApi->ReqUserLogin(&reqUserLogin, 0);
    }

    void ReqAuth()
    {
        CQdpFtdcAuthenticateField reqfield;
        strcpy(reqfield.BrokerID, g_chBrokerID);
        strcpy(reqfield.UserID, g_chUserID);
        strcpy(reqfield.UserProductInfo, "test");
        strcpy(reqfield.AppID, "quantdo_InfiniV8_1");
        strcpy(reqfield.AuthCode, "0f8596818807c41f71cbcc2338e973dd");
        // 发出认证请求
        m_pTraderApi->ReqAuthenticate(&reqfield, 0);
    }

    virtual void OnRspUserLogin(CQdpFtdcRspUserLoginField *pRspUserLogin, CQdpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {
        if (pRspInfo != NULL && pRspInfo->ErrorID != 0)
        {
            std::cout << "用户: " << g_chUserID << "登录失败; 原因: " << pRspInfo->ErrorMsg;
            // REPORT_EVENT(LOG_ERROR, "CTraderSpi::OnRspUserLogin", "Login result: %s", "failed");
            return;
        }
        
        std::cout << "登录成功，开始报单..." << "\n";

        // 启动独立线程用于报单 防止堵塞回调
        orderThread = std::thread(OrderFunc);
    };

    virtual void OnRspAuthenticate(CQdpFtdcRtnAuthenticateField *pRtnAuthenticate, CQdpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast)
    {
        if (pRspInfo != NULL && pRspInfo->ErrorID != 0)
        {
            std::cout << "用户认证失败; 原因: " << pRspInfo->ErrorMsg << "\n";
            // REPORT_EVENT(LOG_ERROR, "CAccountSpi::OnRspUserLogin", "Login result: %s", "failed");
            return;
        }
        if (pRspInfo == NULL)
        {
            std::cout << "OnRspAuthenticate=NULL!\n";
        }
        TQdpFtdcAppTypeType *appType = pRtnAuthenticate->AppID;

        std::cout << "认证成功，客户接入类型为: " << appType << "\n";

        // 认证成功后登录
        ReqLogin();
    };

    virtual void OnRspOrderAction(CQdpFtdcOrderActionField *pOrderAction, CQdpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {
        if(pRspInfo != NULL && pRspInfo->ErrorID != 0)
        {
            std::cout << "用户报单操作失败;原因:" << pRspInfo->ErrorMsg << "\n";
            return;
        }
        if(pRspInfo == NULL){
            std::cout << "OnRspOrderAction=NULL!\n";
        }
    };
    
    virtual void OnRspOrderInsert(CQdpFtdcInputOrderField *pRspInputOrder, CQdpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {
        if (pRspInfo != NULL && pRspInfo->ErrorID != 0)
        {
            std::cout << "下单失败, 原因: " << pRspInfo->ErrorMsg << "; 错误码:" << pRspInfo->ErrorID << "\n";
            return;
        }

        if (pRspInputOrder != NULL)
	    {
             std::cout << "下单成功,LimitPrice=[" << pRspInputOrder->LimitPrice
                << "],InstrumentID=[" << pRspInputOrder->InstrumentID
                << "],Volume=[" << pRspInputOrder->Volume
                << "],UserOrderLocalID=[" << pRspInputOrder->UserOrderLocalID
                << "],OrderSysID=[" << pRspInputOrder->OrderSysID
                << "];\n" ;
        }
    };

    // traderSPI
    virtual void OnRtnTrade(CQdpFtdcTradeField *pTrade)
    {
        std::cout << "OnRtnTrade: OrderSysID=" << pTrade->OrderSysID << ", TradeID=" << pTrade->TradeID << "\n";
    };

    virtual void OnRtnOrder(CQdpFtdcOrderField *pOrder) {
        // store OrderSysID
        std::cout << "OnRtnOrder: OrderSysID=" << pOrder->OrderSysID << ", InstrumentID=" << pOrder->InstrumentID << "\n";
    };

    virtual void OnRtnAck(int nRequestID) {
        //OnRtnAck Received!
        std::cout << "OnRtnAck: nRequestID=" << nRequestID;
    };

private:
    CQdpShmTraderApi *m_pTraderApi; // spi对应的shm api
    std::thread orderThread;
};


void OrderFunc()
{
    //注释了报价相关的请求 需要时打开
    std::this_thread::sleep_for(std::chrono::microseconds(5000));
    std::cout << "开始查询和报单过程\n";
    int RequestID = 0;
    // 操作类型
    int operationType = 0;
    while(1){
        //接受用户输入 执行对应的查询和报单操作
        std::cout << "输入数字执行对应的操作:" << std::endl;
        std::cin >> operationType;
        switch (operationType)
        {
        case 1:
            // 报单录入请求
            ReqOrderInsert(RequestID);
            break;
        case 2:
            // 报单操作请求
            ReqOrderAction(RequestID);
            break;
        default:
            break;
        }
        RequestID++;
    }
}

int ReqOrderAction(int RequestID)
{
    CQdpFtdcOrderActionField ord;
    memset(&ord, 0, sizeof(ord));
    // 交易所
    strcpy(ord.ExchangeID, "SHFE");
    // 被撤订单的本地报单编号
    sprintf(ord.UserOrderLocalID,"%d",g_nOrdLocalID++);
    // 本次撤单操作的本地编号
    sprintf(ord.UserOrderActionLocalID,"%d",5);
    // 报单编号
    strcpy(ord.OrderSysID, "23");
    // 报单操作标志
    ord.ActionFlag = QDP_FTDC_AF_Delete;

    return g_pShmTraderApi->ReqOrderAction(&ord, RequestID);
}

int ReqOrderInsert(int RequestID)
{
    CQdpFtdcInputOrderField ord;
    memset(&ord, 0, sizeof(ord));
    // 投资者编号 (对于API7.0版本,InstrumentIDNum通过合约查询的回调获取)
    strcpy(ord.InvestorID,g_chInvestorID);
    // 合约号
    strcpy(ord.InstrumentID,"IF2412");
    // 本地报单号
    sprintf(ord.UserOrderLocalID,"%d",g_nOrdLocalID);
    // 报单类型
    ord.OrderPriceType = QDP_FTDC_OPT_LimitPrice;
    // 买卖方向
    // strcpy(&(ord.Direction) , "1");
    ord.Direction = QDP_FTDC_D_Buy;
    // 开平标志
    strcpy(&(ord.OffsetFlag), "0");
    // 投机套保标志
    strcpy(&(ord.HedgeFlag), "1");
    // 价格
    ord.LimitPrice = 3074;
    // 数量
    ord.Volume = 1;
    // 有效期类型
    ord.TimeCondition = QDP_FTDC_TC_GFD;
    // 成交量类型
    ord.VolumeCondition = QDP_FTDC_VC_AV;

    return g_pShmTraderApi->ReqOrderInsert(&ord, RequestID);
}

//TODO:添加报单，登录和认证功能
int main(){
    // 产生一个CQdpShmTraderApi实例
    CQdpShmTraderApi* pSupUserApi = CQdpShmTraderApi::CreateShmTraderApi();

    // 保存api
    g_pShmTraderApi = pSupUserApi;

    // 产生一个事件处理的实例
    CShmTraderSpi *spi = new CShmTraderSpi(pSupUserApi);

    // 注册事件处理的实例
    pSupUserApi->RegisterSpi(spi);

    // 设置BrokerID 和 UserID
    strcpy(g_chBrokerID, "guofu");
    strcpy(g_chUserID, "admin");
    strcpy(g_chInvestorID, "0001"); 

    // 设置量投科技服务的地址，可以注册多个地址备用

    //pSupUserApi->RegisterFront("udp://192.168.92.12:6099");//UDP模式
    pSupUserApi->RegisterFront("shm://65432:20");//SHM模式
    pSupUserApi->Connect();

    //创建一个线程 一直调用ReadFromSession以读取信息
    auto t = std::thread([&]()
	{
		while (1)
		{
			
			if (NULL != pSupUserApi)
			{
				int nRet = pSupUserApi->ReadFromSession();
				std::this_thread::sleep_for(std::chrono::milliseconds(100)); //间隔读取
			}
			else
				std::cout << "m_pSuperApi is NULL\n";
		}
	});

    t.join();

    return 0;
}